;
; fli.asm - FLI IDE64 manager plugin
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

vic		= $1f00
p		= $fb
p2		= $fd
p3		= $14
spry		= 248

fli		.macro
		lda #\1
		sta $d011
		lda #\2
		sta $d018
		.endm

fli2		.macro
		inc $d011
		lda #\1
		sta $d018
		.endm

		.include "../contact.inc"

start		sta db+1
		stx i+1
		sty i+2
		jsr $ffbd
		lda #1
		ldx $ba
		ldy #0
		jsr $ffba
		jsr $ffe7
		jsr $ffc0
	    	ldx #1
		jsr $ffc6
		jsr $ffcf
		lda $90
                beq oerr
close           jsr $ffcc
                lda #1
                jmp $ffc3
oerr		jsr $ffcf
		lda #0
		sta $dd
		lda #$3c
		sta $de

		lda $de60
                cmp #"I"
                bne errr
                lda $de61
                cmp #"D"
                bne errr
                lda $de62
                cmp #"E"
                bne errr
		lda #$dd
		ldx #<$4400
		ldy #>$4400
		jsr $def4
		bcc okc
                
                ldx #1
                jsr $ffc6

errr    	ldy #0
belp		jsr $ffcf
		sta ($dd),y
		bit $90
		bvs okc
		iny
		bne belp
		inc $de
		bpl belp

okc		jsr close

		clc
		ldy #25
dwv2		ldx #23
		lda #0
dwv		sta $6000,x
		dex
		bpl dwv
		lda dwv+1
		adc #64
		sta dwv+1
		lda dwv+2
		adc #1
		sta dwv+2
		dey
		bne dwv2

		sei
		lda $2a6
		beq okntsc
		lda #$ea
		sta pal1
		sta pal2
		sta pal3
		sta pal4
		sta pal5
		sta pal6
		sta pal7
		inc pal8+1
		inc pal8+1
		sta pal9
		sta pal10
		sta pal11
		sta pal12
		sta pal13
		sta pal14
                lda #$a9
                sta pal15
                inc pal18+1
                inc pal18+1
                sta pal19
                sta pal20
                lda #$24
                sta pal16
                sta pal16+2
okntsc
                lda #0
		.include "../sprinit.inc"
		ldx #0
oo		lda #0
		sta $8000,x
		sta $8100,x
		lda $3c00,x
		sta $d800,x
		lda $3d00,x
		sta $d900,x
		lda $3e00,x
		sta $da00,x
		lda $3f00,x
		sta $db00,x
		inx
		bne oo
                ldx #7
o2              txa
                sta $83f8,x
		dex
                bpl o2
		stx $4000
		stx $4001
		stx $4002
		lda #9
		sta $d800
		sta $d801
		sta $d802
		lda #36
		sta p2
		lda #$80
		sta p2+1
		.include "../nevki.inc"
		lda #0
		sta p2
		lda #$80
		sta p2+1
		jsr print

		bit $d011
		bpl *-3
		bit $d011
		bmi *-3
		ldx #1
		stx $dd00
		lda #$08
		sta $d018
		dex
		stx $d021
		stx 198
		lda #$78
		sta $d011
		lda #216
		sta $d016
                lda #249
                cmp $d012
                bne *-3
                lda #20
                sta $d012
                lda #$61
                sta $d011
		inc $d019
                sta $d07a		;scpu
		cli
		lda 198
		beq *-2
		sei
                sta $d07b
		bit $d011
		bpl *-3
		bit $d011
		bmi *-3                
		ldx #$2e
io		lda vic,x
		sta $d000,x
		dex
		bpl io
		lda dd00
		sta $dd00
		lda dd02
		sta $dd02
		lda #43
		sta $d011
		lda #$31
		sta $314
		lda #$ea
		sta $315
		lda onmi
		sta 792
		lda onmi+1
		sta 793
		ldx #1
		stx $dc0e
		dex
		stx $d01a
		stx $d020
		stx 198
		cli
		jsr $e544
		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		lda vic+$11
		sta $d011
		lda vic+$20
		sta $d020
		rts

nmi		rti
;---------------------------------------
		.include "../common.inc"

copy	        .text "F"+128,"L"+128,"I"+128," VIEWER1 BY ","S"+128,"OCI/","S"+128,"G"+128,"R"+128," "

		.page
irq		inc $d019
		lda #25
                sta $d012
                lda #<irqx
                sta $314
		lda #$38
		sta $d011
                cli
                jmp *

irqx		.endp
		inc $d019
		lda #20
                sta $d012
                lda #<irq
                sta $314
                pla
                pla
                pla
                pla
                pla
                pla
		lda #2
		sta $dd00
		.page
		ldx #4
		dex
		bne *-1   ;52
pal18           beq *+2
                nop 
                nop

		cmp (0,x)
                
		lda $d012 ;60
		cmp $d012 ;4
		beq *+2   ;7
		ldx #10   
		dex
		bne *-1   ;58
pal19           nop       ;60
                nop       
		lda $d012 ;64
		cmp $d012 ;4
		beq *+2   ;7          
		ldx #10   
		dex
		bne *-1   ;58
pal20           nop       ;60
                nop       
		lda $d012 ;64
		cmp $d012 ;4
		beq *+2   ;7          
		lda #47
		cmp $d012
		bne *-3
		ldx #11
		dex
		bne *-1
pal16           cmp ($ea,x)
                cmp (0),y
		nop
                cmp (0,x)
		ldx #24
		#fli $38,$18
ff		ldy #$61
		lda #$39
		sta $d011-$61,y
		lda #$28
		sta $d018
                nop
pal1		cmp ($ea,x)
		cmp (0),y
		#fli2 $38
                nop
pal2    	cmp ($ea,x)
		cmp (0),y
		#fli2 $48
                nop
pal3    	cmp ($ea,x)
		cmp (0),y
		#fli2 $58
                nop
pal4    	cmp ($ea,x)
		cmp (0),y
		#fli2 $68
                nop
pal5    	cmp ($ea,x)
		cmp (0),y
		#fli2 $78
                nop
pal6    	cmp ($ea,x)
		cmp (0),y
		#fli2 $08
                nop
pal7    	cmp ($ea,x)
		cmp (0),y
		#fli $38,$18
		cmp (0),y
		dex
pal8    	bne ff
		.endp
pal15           nop
		nop
		#fli2 $28
                nop
pal9 		cmp ($ea,x)
		cmp (0),y
		#fli2 $38
                nop
pal10		cmp ($ea,x)
		cmp (0),y
		#fli2 $48
                nop
pal11		cmp ($ea,x)
		cmp (0),y
		#fli2 $58
                nop
pal12		cmp ($ea,x)
		cmp (0),y
		#fli2 $68
                nop
pal13   	cmp ($ea,x)
		cmp (0),y
		#fli2 $78
                nop
pal14		cmp ($ea,x)
		cmp (0),y
		#fli2 $08
                nop
		sty $d011
		sty $dd00
		jsr $ea87
		jmp $ea81

dd00
		*= *+1
dd02
		*= *+1
onmi
		*= *+2
