;
; ifli.asm - IFLI IDE64 manager plugin
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

colors		= $1e00
vic		= $1f00
p		= $fb
p2		= $fd
p3		= $14
spry		= 248

fli		.macro
		lda #\1
		sta $d011
		lda #\2
		sta $d018
		lda \3,x
		sta $d021
		.endm

fli2		.macro
		inc $d011
		lda #\1
		sta $d018
		lda \2,x
		sta $d021
		.endm

		.include "../contact.inc"

start		sta db+1
		stx i+1
		sty i+2
		jsr $ffbd
		lda #1
		ldx $ba
		ldy #0
		jsr $ffba
		jsr $ffe7
		jsr $ffc0
		ldx #1
		jsr $ffc6

		lda #<nmi
		sta $fffa
		lda #>nmi
		sta $fffb

		jsr $ffcf
                lda $90
                beq oerr
close		jsr $ffcc
		lda #1
                jmp $ffc3
oerr    	jsr $ffcf

		lda #$40
		sta $de
		ldx #<$4400
                stx $dd
		ldy #>$4400
		jsr read

		lda #$c0
		sta $de
		ldx #<$1000
                stx $dd
		ldy #>$1000
		jsr read

		lda #$90
		sta $de
		ldx #<$1000
                stx $dd
		ldy #>$1000
		jsr read

		sei
		inc $1
		ldy #16
		ldx #0
fj		lda $9000,x
		sta $d000,x
		inx
		bne fj
		inc fj+2
		inc fj+5
		dey
		bne fj
		dec $1
		cli

                sty $dd
		lda #$e0
		sta $de
		ldx #<$1f40
		ldy #>$1f40
		jsr read

		jsr close

		sei
                lda $2a6
                beq okntsc
                inc pal18+1
                inc pal18+1
                lda #$a9
                sta pal19
                sta pal20
                lda #<palfli
                sta pal1+1
                lda #>palfli
                sta pal1+2
okntsc
		lda #0
		.include "../sprinit.inc"
		ldx #0
oo		lda $8000,x
		sta $d800,x
		lda $8100,x
		sta $d900,x
		lda $8200,x
		sta $da00,x
		lda $8300,x
		sta $db00,x
		lda #0
		sta $8000,x
		sta $8100,x
		inx
		bne oo
		lda #$4f
		sta p
		lda #$7f
		sta p+1
		ldx #0
		ldy #0
we		lda (p),y
		sta colors+(25*0),x
		iny
		cpy #177
		bne sd
		ldy #0
		lda #$e8
		sta p
		lda #$c3
		sta p+1
sd		lda (p),y
		sta colors+(25*1),x
		iny
		lda (p),y
		sta colors+(25*2),x
		iny
		lda (p),y
		sta colors+(25*3),x
		iny
		lda (p),y
		sta colors+(25*4),x
		iny
		lda (p),y
		sta colors+(25*5),x
		iny
		lda (p),y
		sta colors+(25*6),x
		iny
		lda (p),y
		sta colors+(25*7),x
		iny
		inx
		cpx #25
		bne we
		ldx #7
o2		txa
		sta $83f8,x
		dex
		bpl o2
		stx $4000
		stx $4001
		stx $4002
		stx $c000
		stx $c001
		stx $c002
		lda #9
		sta $d800
		sta $d801
		sta $d802
		lda #36
		sta p2
		lda #$80
		sta p2+1
		.include "../nevki.inc"
		lda #0
		sta p2
		lda #$80
		sta p2+1
		jsr print

		bit $d011
		bpl *-3
		bit $d011
		bmi *-3
		ldx #1
		stx $dd00
		lda #$08
		sta $d018
		dex
		stx $d021
		stx 198
		lda #$78
		sta $d011
		lda #216
		sta $d016
                lda #249
                cmp $d012
                bne *-3
                lda #20
                sta $d012
                lda #$61
                sta $d011
		inc $d019
                sta $d07a		;scpu
		cli
		lda 198
		beq *-2
		sei
                sta $d07b
		bit $d011
		bpl *-3
		bit $d011
		bmi *-3                
		ldx #$2e
io		lda vic,x
		sta $d000,x
		dex
		bpl io
		lda dd00
		sta $dd00
		lda dd02
		sta $dd02
		lda #43
		sta $d011
		lda #$31
		sta $314
		lda #$ea
		sta $315
		lda onmi
		sta 792
		lda onmi+1
		sta 793
		ldx #1
		stx $dc0e
		dex
		stx $d01a
		stx $d020
		stx 198
		cli
		jsr $e544
		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		lda vic+$11
		sta $d011
		lda vic+$20
		sta $d020
		rts

nmi		rti
;---------------------------------------
copy            .text "I"+128,"F"+128,"L"+128,"I"+128," VIEWER1 BY ","S"+128,"OCI/","S"+128,"G"+128,"R"+128

		.page
irq		inc $d019
		lda #25
                sta $d012
                lda #<irqx
                sta $314
		lda #$38
		sta $d011
                cli
                jmp *

irqx		inc $d019
                .endp
		lda #20
                sta $d012
                lda #<irq
                sta $314
                pla
                pla
                pla
                pla
                pla
                pla
ez		lda #2
		sta $dd00
		.page
		ldx #4
		dex
		bne *-1   ;52
pal18           beq *+2
                nop 
                nop

		cmp (0,x)
                
		lda $d012 ;60
		cmp $d012 ;4
		beq *+2   ;7
		ldx #10   
		dex
		bne *-1   ;58
pal19           nop       ;60
                nop       
		lda $d012 ;64
		cmp $d012 ;4
		beq *+2   ;7          
		ldx #10   
		dex
		bne *-1   ;58
pal20           nop       ;60
                nop       
		lda $d012 ;64
		cmp $d012 ;4
		beq *+2   ;7          
		lda #47
		cmp $d012
		bne *-3
		ldx #10
		dex
		bne *-1
                .endp
                
		lda colors
pal1		jsr ntscfli

		lda ez+1
		eor #2
		sta ez+1
		lda $d016
		eor #1
		sta $d016

		jsr $ea87
		jmp $ea81

ntscfli		cmp (0),y
		sta $d021
		#fli $38,$18,colors+(25*1)
                ldy #$61
ff      	#fli2 $28,colors+(25*2)
		cmp (0),y
		inc $d011
		lda #$38
		sta $d018
		lda colors+(25*3),x
		sta $d021-$61,y
		nop
                nop
		inc $d011
		lda #$48
		sta $d018
		lda colors+(25*4),x
		sta $d021-$61,y
		nop
                nop
		inc $d011
		lda #$58
		sta $d018
		lda colors+(25*5),x
		sta $d021-$61,y
		nop
                nop
		#fli2 $68,colors+(25*6)
		cmp (0),y
		#fli2 $78,colors+(25*7)
		inx
                nop
		lda #$3f
		sta $d011-$61,y
		lda #$08
		sta $d018
		lda colors,x
		sta $d021
		cpx #24
                nop
		lda #$38
		sta $d011-$61,y
		lda #$18
		sta $d018
		lda colors+(25*1),x
		sta $d021
                .page
                bcs *+5
		jmp ff
                .endp

                nop
		lda #$39
		sta $d011
		lda #$28
		sta $d018
		lda colors+(25*2),x
		sta $d021
		cmp (0),y
		#fli2 $38,colors+(25*3)
		cmp (0),y
		#fli2 $48,colors+(25*4)
		cmp (0),y
		#fli2 $58,colors+(25*5)
		cmp (0),y
		#fli2 $68,colors+(25*6)
		cmp (0),y
		#fli2 $78,colors+(25*7)
		cmp (0),y
		inc $d011
		lda #$08
		sta $d018
		lda #0
		sta $d021
                nop
		sty $d011
		sty $dd00
		rts

palfli		ldy #$61
		sta $d021
		#fli $38,$18,colors+(25*1)
                .page
ff2     	#fli2 $28,colors+(25*2)
		bit $ea
		inc $d011
		lda #$38
		sta $d018
		lda colors+(25*3),x
		sta $d021-$61,y
		nop
		inc $d011
		lda #$48
		sta $d018
		lda colors+(25*4),x
		sta $d021-$61,y
		nop
		inc $d011
		lda #$58
		sta $d018
		lda colors+(25*5),x
		sta $d021-$61,y
		nop
		#fli2 $68,colors+(25*6)
		bit $ea
		#fli2 $78,colors+(25*7)
		inx
		lda #$3f
		sta $d011-$61,y
		lda #$08
		sta $d018
		lda colors,x
		sta $d021
		cpx #24
		lda #$38
		sta $d011-$61,y
		lda #$18
		sta $d018
		lda colors+(25*1),x
		sta $d021
                bcc ff2
                .endp
		lda #$39
		sta $d011-$61,y
		lda #$28
		sta $d018
		lda colors+(25*2),x
		sta $d021
		bit $ea
		#fli2 $38,colors+(25*3)
		bit $ea
		#fli2 $48,colors+(25*4)
		bit $ea
		#fli2 $58,colors+(25*5)
		bit $ea
		#fli2 $68,colors+(25*6)
		bit $ea
		#fli2 $78,colors+(25*7)
		bit $ea
		inc $d011
		lda #$08
		sta $d018
		lda #0
		sta $d021
		sty $d011
		sty $dd00
		rts

		.include "../common.inc"

read            .proc
		txa
		eor #255
                sta p3
                tya
                eor #255
                sta p3+1
		lda $de60
                cmp #"I"
                bne errr
                lda $de61
                cmp #"D"
                bne errr
                lda $de62
                cmp #"E"
                bne errr
		lda #$dd
		jsr $def4
                bcc ki

		ldx #1
		jsr $ffc6

errr		ldy #0
lp		lda $90
		bne ki
                inc p3
                bne kq
                inc p3+1
                beq ki
kq		jsr $ffcf
		sta ($dd),y
		iny
		bne lp
		inc $de
		bne lp
                
ki		rts
                .pend

dd00
		*= *+1
dd02
		*= *+1
onmi
		*= *+2


