;
; kla.asm - Koala paint IDE64 manager plugin
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

vic		= $1f00
p		= $14
p2		= $fb
p3		= $fd
spry		= 251

		.include "../contact.inc"

start		sta db+1
		stx i+1
		sty i+2
		jsr $ffbd
		lda #1
		ldx $ba
		ldy #0
		jsr $ffba
		jsr $ffe7
		jsr $ffc0
		ldx #1
		jsr $ffc6
		jsr $ffcf
                lda $90
                beq oerr
close		jsr $ffcc
		lda #1
                jmp $ffc3
oerr    	jsr $ffcf

		lda #0
		sta $dd
		lda #$40
		sta $de

		lda $de60
                cmp #"I"
                bne errr
                lda $de61
                cmp #"D"
                bne errr
                lda $de62
                cmp #"E"
                bne errr
		lda #$dd
		ldx #<10240
		ldy #>10240
		jsr $def4
		bcc okc
                
                ldx #1
                jsr $ffc6

errr		ldx #0
		ldy #0
belp		bit $90
		bvs okc2
		jsr $ffcf
		sta ($dd),y
		iny
		bne belp
		inc $de
		inx
		cpx #$28
		bne belp
okc2		txa
		pha
                tya
                tax
                pla
                tay

okc	        cpx #<10001
		bne b
		cpy #>10001
		bne b
                inc comp+1
b		jsr close

comp		lda #0
		bne xxxx
		lda #$40
                sta p+1
		lda #$80
                sta p2+1
		ldy #0
                sty p
                sty p2
tni             lda (p),y
                cmp #$fe
                bne ncm
                inc p
                bne *+4
                inc p+1
                lda (p),y
                pha
                inc p
                bne *+4
                inc p+1
                lda (p),y
                tax
                inc p
		bne *+4
                inc p+1
                stx uuq+1
                pla
ccp             sta (p2),y
                iny
                bne cg
                inc p+1
                inc p2+1
                pha
                lda p2+1
                cmp #$a8
                pla
                bcs ek
cg      	dex
                bne ccp

                lda p
                sec
uuq             sbc #0
                sta p
                bcs tni
                dec p+1
                jmp tni
                
ncm		sta (p2),y
		iny
                bne tni
                inc p2+1
                inc p+1
                lda p2+1
                cmp #$a8
                bcc tni
ek
		lda #$36
                sta $1
		ldx #0
                ldy #$28
cu              lda $8000,x
                sta $4000,x
                inx
                bne cu
                inc cu+2
                inc cu+5
                dey
                bne cu
                lda #$37
                sta $1
xxxx
		sei
		lda $4000+10000
                sta bg
		.include "../sprinit.inc"
		ldy #0
d		lda $6328,y
		sta $d800,y
		lda $6428,y
		sta $d900,y
		lda $6528,y
		sta $da00,y
		lda $6628,y
		sta $db00,y
		iny
		bne d
		tya
nn		sta $6400,y
		sta $6500,y
		iny
		bne nn
		ldy #7
qw		tya
		ora #128+16
		sta $63f8,y
		dey
		bpl qw
		lda #36
		sta p2
		lda #$64
		sta p2+1
		.include "../nevki.inc"
		lda #0
		sta p2
		lda #$64
		sta p2+1
		jsr print

		ldx #$e7
		ldy #4
qw1		lda $6240,x
		sta $6300,x
		dex
		cpx #255
		bne qw1
		dec qw1+2
		dec qw1+5
		dey
		bne qw1

		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		lda #2
		sta $dd00
		lda #$80
		sta $d018
		lda bg
		sta $d021
                lsr
                lsr
                lsr
                lsr
		sta $d020
		lda #249
		sta $d012
		lda #59
		sta $d011
		lda #216
		sta $d016
		inc $d019
		lda #0
		sta 198
		sta $7fff
                sta $d07a		;scpu
		cli
		lda 198
		beq *-2
		sei
                sta $d07b
		bit $d011
		bmi *-3
		ldx #$2e
io		lda vic,x
		sta $d000,x
		dex
		bpl io
		lda dd00
		sta $dd00
		lda dd02
		sta $dd02
		lda #43
		sta $d011
		lda #$31
		sta $314
		lda #$ea
		sta $315
		lda onmi
		sta 792
		lda onmi+1
		sta 793
		ldx #1
		stx $dc0e
		dex
		stx $d01a
                stx $d020
		stx 198
		cli
		jsr $e544
		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		lda vic+$11
		sta $d011
		lda vic+$20
		sta $d020
		rts

nmi		rti
;---------------------------------------
		.include "../common.inc"

copy            .text "K"+128,"L"+128,"A"+128," VIEWER1 BY ","S"+128,"OCI/","S"+128,"G"+128,"R"+128," "

irq		inc $d019
		lda $d012
		bpl irq2
		ldx #51
		stx $d011
		dex
		stx $d012
		ldx #10
		dex
		bne *-1
		lda $d020
		sta $d021,x
		jmp $ea31
irq2		lda #59
		sta $d011
		lda bg
		sta $d021
		lda #249
		sta $d012
		jmp $ea81
dd00
		*= *+1
dd02
		*= *+1
onmi
		*= *+2
bg
		*= *+1
