;
; shi.asm - Super hires interlace IDE64 manager plugin
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

vic		= $1f00
p		= $14
p2		= $fb
p3		= $fd
spry		= 251

		.include "../contact.inc"

start		sta db+1
		stx i+1
		sty i+2
		jsr $ffbd
		lda #1
		ldx $ba
		ldy #0
		jsr $ffba
		jsr $ffe7
		jsr $ffc0
		ldx #1
		jsr $ffc6
		jsr $ffcf
                lda $90
                beq oerr
close		jsr $ffcc
		lda #1
                jmp $ffc3
oerr    	jsr $ffcf

		lda #0
		sta $dd
	       	lda #$80
		sta $de

		jsr $ffcf
                sta comp
                cmp #0
                beq ok
                
                lda #$40
		sta $de

ok      	lda $de60
                cmp #"I"
                bne errr
                lda $de61
                cmp #"D"
                bne errr
                lda $de62
                cmp #"E"
                bne errr
		lda #$dd
		ldx #<16384
		ldy #>16384
		jsr $def4
		bcc okc
                
                ldx #1
                jsr $ffc6

errr		ldy #0
belp		jsr $ffcf
		sta ($dd),y
		bit $90
		bvs okc
		iny
		bne belp
		inc $de
		ldx $de
		cpx #$68
		bne belp

okc	        jsr close

		lda comp
                beq nocomp
                
                ldy #0
                sty p
                sty p2
                lda #$40
                sta p+1
                lda #$80
                sta p2+1
                
loop            lda (p),y
                inc p
                bne *+4
                inc p+1
                tax
                bmi rlc

rr              lda (p),y
                sta (p2),y
                iny
                bne nn1
                inc p+1
                inc p2+1
                lda p2+1
                cmp #$c0
                bcs nocomp
nn1             dex
                bne rr
                beq loop

rlc		lda (p),y
                inc p
                bne *+4
                inc p+1
                dex
rr2             sta (p2),y
                inc p2 
                bne nn2
                inc p2+1
                pha
                lda p2+1
                cmp #$c0
                pla
                bcs nocomp
nn2             dex
                bmi rr2
                bpl loop

                
nocomp  	sei
                lda $2a6
                beq okntsc
                inc pal18+1
                inc pal18+1
                lda #$a9
                sta pal19
                sta pal20
                lda #3
                sta pal1+1
		lda #$ea
                sta pal2
                lda #17
                sta pal3+1
okntsc
                lda #0
		.include "../sprinit.inc"
                ldy #0
		tya
nn		sta $7c00,y
		sta $7d00,y
		iny
		bne nn
		ldy #7
qw		tya
		ora #240
		sta $7ff8,y
		dey
		bpl qw
		lda #15
		sta p2
		lda #$7c
		sta p2+1
		.include "../nevki.inc"
		lda #42
		sta p2
		lda #$7c
		sta p2+1
		jsr print

		ldx #2
ux              lda $7c3f,x
                sta $7c00,x
                lda $7c7f,x
                sta $7c40,x
                lda $7cbf,x
                sta $7c80,x
                lda $7cff,x
                sta $7cc0,x
                lda $7d3f,x
                sta $7d00,x
                lda $7d7f,x
                sta $7d40,x
                lda $7dbf,x
                sta $7d80,x
                lda $7dff,x
                sta $7dc0,x
                dex
                bpl ux

                lda #$34
		sta $1
                
                ldx #0
                ldy #8
                txa
if              sta $7400,x
                sta $f400,x
                inx
                bne if
                inc if+2
                inc if+5
                dey
                bne if

  		ldy #25		;copy bitmap
lp      	ldx #95
h       	lda $8000,x
                sta $4070,x
		lda $8960,x
                sta $c070,x
                dex
                bpl h
                
                lda h+1
                clc
                adc #96
                sta h+1
                bcc *+5
                inc h+2
                
                lda h+4
                clc
                adc #64
                sta h+4
                sta h+10
                inc h+5
                inc h+11
                bcc xk2
                inc h+5
                inc h+11
xk2
                lda h+7
                clc
                adc #96
                sta h+7
                bcc *+5
                inc h+8

                ldx #11		;copy colors
i3              lda $bac0,x
                sta $740e,x
                sta $f40e,x
                sta $780e,x
                sta $f80e,x
                dex
                bpl i3
                
                lda i3+1
                clc
                adc #12
                sta i3+1
                bcc *+5
                inc i3+2
                
                lda i3+4
                clc
                adc #40
                sta i3+4
                sta i3+7
                sta i3+10
                sta i3+13
                bcc xk
                inc i3+5
                inc i3+8
                inc i3+11
                inc i3+14
xk
                dey
                bne lp
                
                ldx #20         ;copy sprites
i2              lda $92c0,y
                sta $6000,y
                lda $a6c0,y
                sta $e000,y
                iny
                bne i2
                inc i2+2
                inc i2+5
                inc i2+8
                inc i2+11
                dex
                bne i2
                
                lda #$36
                sta $1
                
		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		lda #2
		sta $dd00
		lda #$d0
		sta $d018
		lda #0
		sta $d021
		lda #38
		sta $d012
		lda #59
		sta $d011
		lda #200
		sta $d016
		inc $d019
		lda #0
		sta 198
                sta $d07a		;scpu
		cli
		lda 198
		beq *-2
		sei
                lda #$37
                sta $1
                sta $d07b
		bit $d011
		bmi *-3
		ldx #$2e
io		lda vic,x
		sta $d000,x
		dex
		bpl io
		lda dd00
		sta $dd00
		lda dd02
		sta $dd02
		lda #43
		sta $d011
		lda #$31
		sta $314
		lda #$ea
		sta $315
		lda onmi
		sta 792
		lda onmi+1
		sta 793
		ldx #1
		stx $dc0e
		dex
		stx $d01a
                stx $d020
		stx 198
		cli
		jsr $e544
		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		lda vic+$11
		sta $d011
		lda vic+$20
		sta $d020
		rts

nmi		rti
;---------------------------------------
		.include "../common.inc"

wys		sta $d001
		sta $d003
		sta $d005
		sta $d007
		sta $d009
		sta $d00b
		sta $d00d
		sta $d00f
		rts

		.page
irq		inc $d019
		lda #40
                sta $d012
                lda #<irqx
                sta $314
		lda #$3b
		sta $d011
                cli
                jmp *

irqx		inc $d019
                .endp
		lda #38
                sta $d012
                lda #<irq
                sta $314
                pla
                pla
                pla
                pla
                pla
                pla
ez		lda #2
		sta $dd00
		.page
		ldx #4
		dex
		bne *-1   ;52
pal18           beq *+2
                nop 
                nop

		cmp (0,x)
                
		lda $d012 ;60
		cmp $d012 ;4
		beq *+2   ;7
		ldx #10   
		dex
		bne *-1   ;58
pal19           nop       ;60
                nop       
		lda $d012 ;64
		cmp $d012 ;4
		beq *+2   ;7          
		ldx #10   
		dex
		bne *-1   ;58
pal20           nop       ;60
                nop       
		lda $d012 ;64
		cmp $d012 ;4
		beq *+2   ;7          
                .endp

                lda #136+24*0
                sta $d000
                sta $d008
                lda #136+24*1
                sta $d002
                sta $d00a
                lda #136+24*2
                sta $d004
                sta $d00c
                lda #136+24*3
                sta $d006
                sta $d00e
                ldy #7
                .page
k               lda $bbec,y
                sta $d027,y
                dey
                bpl k
                .endp
                lda #0
                sta $d010

		lda #50+21*0
		ldx #$80
		jsr place1		;kek1
		lda #$d0
		sta $d018

		lda #50+21*1-4
                jsr pausa
		lda #50+21*1
		ldx #$88
		jsr place2		;piros1
		lda #$e0
		sta $d018

		lda #50+21*2-5
                jsr pausa
		lda #50+21*2
		ldx #$90
		jsr place1		;kek2
		lda #$d0
		sta $d018

		lda #50+21*3-4
                jsr pausa
		lda #50+21*3
		ldx #$98
		jsr place2		;piros2
		lda #$e0
		sta $d018
                
		lda #50+21*4-5
                jsr pausa
		lda #50+21*4
		ldx #$a0
		jsr place1		;kek3
		lda #$d0
		sta $d018

		lda #50+21*5-5
                jsr pausa
		lda #50+21*5
		ldx #$a8
		jsr place2		;piros3
pal1            ldx #5
                .page
                dex
                bne *-1
                .endp
pal2            lda #$ea
		nop
		lda #$e0
		sta $d018

		lda #50+21*6-5
                jsr pausa
		lda #50+21*6
		ldx #$b0
		jsr place1		;kek4
                cmp (0,x)
                cmp (0,x)
                cmp (0,x)
                cmp (0,x)
                cmp (0,x)
		lda #$d0
		sta $d018

		lda #50+21*7-5
                jsr pausa
		lda #50+21*7
		ldx #$b8
		jsr place2		;piros4
		lda #$e0
		sta $d018

		lda #50+21*8-4
                jsr pausa
		lda #50+21*8
		ldx #$c0
		jsr place1              ;kek5
		lda #$d0
		sta $d018

		lda #50+21*9-4
                jsr pausa
		lda #50+21*9
		ldx #$c8
		jsr place2	       	;piros5
		lda #$e0
		sta $d018

		lda ez+1
		eor #2
		sta ez+1

		lda #249
                jsr pausa                
		lda #$33
                sta $d011
                cmp (0,x)
                cmp (0,x)

                lda #255
                sta $d010
                lda #88+24*0
                sta $d000
                lda #88+24*1
                sta $d002
                lda #88+24*2
                sta $d004
                lda #88+24*3
                sta $d006
                lda #88+24*4
                sta $d008
                lda #88+24*5
                sta $d00a
                lda #88+24*6
                sta $d00c
                lda #1
                sta $d027
                sta $d028
                sta $d029
                sta $d02a
                sta $d02b
                sta $d02c
                sta $d02d
                sta $d02e
                lda #2
                sta $dd00
                lda #$f0
                sta $d018
                lda #0
                sta $d00e
                lda #128
                sta $d010
                lda #50+21*10-256
                jsr wys
                lda $d012
                bmi *-3
pal3            lda #8;17
                jsr pausa
                lda #255
                sta $d010
                sta $d00e
		jmp $ea31

		.page
pausa		cmp $d012
		bcs pausa
		rts
                .endp

place1		jsr wys
		stx $77f8
		stx $f7f8
		inx
		stx $77f9
		stx $f7f9
		inx
		stx $77fa
		stx $f7fa
		inx
		stx $77fb
		stx $f7fb
		inx
		stx $77fc
		stx $f7fc
		inx
		stx $77fd
		stx $f7fd
		inx
		stx $77fe
		stx $f7fe
		inx
		stx $77ff
		stx $f7ff
		rts
                
place2		jsr wys
		stx $7bf8
		stx $fbf8
		inx
		stx $7bf9
		stx $fbf9
		inx
		stx $7bfa
		stx $fbfa
		inx
		stx $7bfb
		stx $fbfb
		inx
		stx $7bfc
		stx $fbfc
		inx
		stx $7bfd
		stx $fbfd
		inx
		stx $7bfe
		stx $fbfe
		inx
		stx $7bff
		stx $fbff
		rts

copy            .text "S"+128,"H"+128,"I"+128," VIEWER1 BY ","S"+128,"OCI/","S"+128,"G"+128,"R"+128," "

dd00
		*= *+1
dd02
		*= *+1
onmi
		*= *+2
comp
		*= *+1

        	.comment
		*=$92c0+512*0
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
		*=$92c0+512*0+60
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255

		*=$92c0+512*1+256
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
		*=$92c0+512*1+256+60
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255

		*=$92c0+512*2
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
		*=$92c0+512*2+60
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255

		*=$92c0+512*3+256
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
		*=$92c0+512*3+256+60
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255

		*=$92c0+512*4
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
		*=$92c0+512*4+60
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255

		*=$92c0+512*5+256
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
		*=$92c0+512*5+256+60
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255

		*=$92c0+512*6
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
		*=$92c0+512*6+60
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255

		*=$92c0+512*7+256
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
		*=$92c0+512*7+256+60
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255

		*=$92c0+512*8
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
		*=$92c0+512*8+60
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255

		*=$92c0+512*9+256
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
		*=$92c0+512*9+256+30
                .byte 255,255,255,85,85,85
                *=*+58
                .byte 255,255,255,85,85,85
                *=*+58
                .byte 255,255,255,85,85,85
                *=*+58
                .byte 255,255,255,85,85,85

		*=$92c0+512*9+30
                .byte 255,255,255,170,170,170
                *=*+58
                .byte 255,255,255,170,170,170
                *=*+58
                .byte 255,255,255,170,170,170
                *=*+58
                .byte 255,255,255,170,170,170



		*=$a6c0+512*0
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
		*=$a6c0+512*0+60
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255

		*=$a6c0+512*1+256
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
		*=$a6c0+512*1+256+60
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255

		*=$a6c0+512*2
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
		*=$a6c0+512*2+60
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255

		*=$a6c0+512*3+256
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
		*=$a6c0+512*3+256+60
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255

		*=$a6c0+512*4
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
		*=$a6c0+512*4+60
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255

		*=$a6c0+512*5+256
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
		*=$a6c0+512*5+256+60
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255

		*=$a6c0+512*6
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
		*=$a6c0+512*6+60
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255

		*=$a6c0+512*7+256
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
		*=$a6c0+512*7+256+60
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255

		*=$a6c0+512*8
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
		*=$a6c0+512*8+60
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255

		*=$a6c0+512*9+256
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
                *=*+61
                .byte 255,255,255
		*=$a6c0+512*9+256+30
                .byte 255,255,255,85,85,85
                *=*+58
                .byte 255,255,255,85,85,85
                *=*+58
                .byte 255,255,255,85,85,85
                *=*+58
                .byte 255,255,255,85,85,85

		*=$a6c0+512*9+30
                .byte 205,255,255,170,170,170
                *=*+58
                .byte 205,255,255,170,170,170
                *=*+58
                .byte 205,255,255,170,170,170
                *=*+58
                .byte 205,255,205,170,170,170

		*=$bbec
                
                .byte 6,6,6,6,2,2,2,2
                .endc
                
